package zk.support.vw;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;

import org.zkoss.bind.GlobalCommandEvent;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zk.ui.event.Events;
import org.zkoss.zk.ui.event.MouseEvent;
import org.zkoss.zk.ui.select.SelectorComposer;
import org.zkoss.zk.ui.select.annotation.Wire;
import org.zkoss.zul.Button;
import org.zkoss.zul.Checkbox;
import org.zkoss.zul.DefaultTreeModel;
import org.zkoss.zul.DefaultTreeNode;
import org.zkoss.zul.Label;
import org.zkoss.zul.Tree;
import org.zkoss.zul.TreeModel;
import org.zkoss.zul.TreeNode;
import org.zkoss.zul.Treecell;
import org.zkoss.zul.Treeitem;
import org.zkoss.zul.TreeitemRenderer;
import org.zkoss.zul.Treerow;

public class TreeDemoComposerTemplate extends SelectorComposer<Component> {

	@Wire("#tree")
	private Tree tree;
	
	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);
		tree.setModel(getTreeModel());
	}
	
	public TreeModel<TreeNode<Payload>> getTreeModel() {
		final List<DefaultTreeNode<Payload>> children = new ArrayList<DefaultTreeNode<Payload>>();
		final DefaultTreeNode<Payload> root = new DefaultTreeNode<Payload>(
				null, children);

		System.out.println(System.currentTimeMillis());

		for (int i = 0; i < sizes.length; i++) {
			Payload p = new Payload(i + "");
			DefaultTreeNode<Payload> childNode = new DefaultTreeNode<Payload>(
					p, new ArrayList<DefaultTreeNode<Payload>>());

			for (int j = 0; j < sizes[i]; j++) {
				p = new Payload(i + "." + j);
				DefaultTreeNode<Payload> childChildNode = new DefaultTreeNode<Payload>(
						p);
				childNode.add(childChildNode);
			}

			root.add(childNode);
		}

		System.out.println(System.currentTimeMillis());

		return new DefaultTreeModel<Payload>(root) {
			int i, j, k, l; 
			
			@Override
			public boolean isLeaf(TreeNode<Payload> node) {
				i++;
				System.out.println(i + ", " + j + ", " + k + ", " + l);
				return super.isLeaf(node);
			}
			
			@Override
			public TreeNode<Payload> getChild(TreeNode<Payload> parent,
					int index) {
				j++;
				System.out.println(i + ", " + j + ", " + k + ", " + l + " parent:" + parent + index);
				return super.getChild(parent, index);
			}
			
			@Override
			public TreeNode<Payload> getChild(int[] path) {
				k++;
				System.out.println(i + ", " + j + ", " + k + ", " + l);
				return super.getChild(path);
			}
			
			@Override
			public int getChildCount(TreeNode<Payload> parent) {
				l++;
				System.out.println(i + ", " + j + ", " + k + ", " + l);
				return super.getChildCount(parent);
			}
		};
	}

	private static int sizes[] = { 1234, 1188, 1016, 897, 602, 547, 518, 253,
			251, 236, 230, 220, 175, 167, 146, 121, 114, 108, 106, 98, 98, 97,
			93, 91, 91, 86, 84, 74, 72, 68, 68, 65, 62, 62, 62, 61, 61, 59, 57,
			57, 55, 52, 52, 51, 48, 47, 46, 44, 44, 43, 40, 40, 39, 39, 38, 37,
			37, 37, 37, 37, 37, 36, 36, 35, 35, 35, 34, 33, 33, 32, 31, 30, 30,
			30, 29, 29, 29, 28, 28, 28, 28, 28, 27, 27, 27, 27, 27, 26, 26, 26,
			26, 26, 26, 24, 24, 24, 24, 24, 24, 24, 23, 23, 23, 23, 23, 23, 23,
			23, 23, 23, 22, 22, 22, 22, 22, 21, 21, 21, 21, 21, 21, 21, 21, 21,
			21, 20, 20, 20, 20, 20, 20, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19,
			18, 18, 18, 18, 18, 18, 18, 17, 17, 17, 17, 16, 16, 16, 16, 16, 15,
			15, 15, 15, 14, 14, 14, 14, 14, 14, 14, 14, 14, 13, 13, 13, 13, 13,
			13, 13, 13, 13, 13, 13, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12,
			12, 12, 12, 12, 12, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,
			11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 10, 10, 10, 10, 10, 10,
			10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10,
			10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 9, 9, 9, 9, 9, 9, 9, 9, 9,
			9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9,
			9, 9, 9, 9, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8,
			8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 7, 7, 7, 7, 7, 7,
			7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 6, 6, 6, 6,
			6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6,
			6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 5, 5, 5, 5, 5, 5, 5, 5,
			5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5,
			5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 4, 4, 4, 4, 4, 4, 4, 4, 4,
			4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4,
			4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 3, 3, 3, 3, 3,
			3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
			3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
			3, 3, 3, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
			2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
			2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
			2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
			2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
			2, 1, 1, 1, 1, 1, 1 };

}
